import _dropRightWhile from 'lodash/fp/dropRightWhile';
import _dropWhile from 'lodash/fp/dropWhile';
import _includes from 'lodash/fp/includes';
import _takeWhile from 'lodash/fp/takeWhile';

// 

const inputGetSharedTypes = (get, input1, input2) => _takeWhile(type => get(type, input1) === get(type, input2));

const outputTrimLeft = sharedTypes => _dropWhile(part => _includes(part.type, sharedTypes));

const outputTrimRight = sharedTypes => _dropRightWhile(part => _includes(part.type, sharedTypes));

const separator = {
  type: 'literal',
  value: '–'
};

var range = ((types, inputGetter, ltr, input1, input2, output1, output2) => {
  const sharedTypes = inputGetSharedTypes(inputGetter, input1, input2)(types);
  const left = outputTrimRight(sharedTypes)(ltr ? output1 : output2);
  const right = outputTrimLeft(sharedTypes)(ltr ? output2 : output1);
  return [...left, separator, ...right];
});

export default range;
//# sourceMappingURL=range.js.map
